Last Comment Bug 356831 - Proxy autodiscovery doesn't check DHCP (option 252)
: Proxy autodiscovery doesn't check DHCP (option 252)
Status: NEW
[necko-backlog]
:
Product: Core
Classification: Components
Component: Networking: HTTP (show other bugs)
: Trunk
: All All
: -- normal with 31 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
: Patrick McManus [:mcmanus]
Mentors:
: 440547 (view as bug list)
Depends on:
Blocks: 350759 fx-enterprise
  Show dependency treegraph
 
Reported: 2006-10-16 08:36 PDT by Fran Boon
Modified: 2016-11-28 23:16 PST (History)
39 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Fran Boon 2006-10-16 08:36:51 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.7) Gecko/20060909 Firefox/1.5.0.7
Build Identifier: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.7) Gecko/20060909 Firefox/1.5.0.7

proxy autodiscovery can theoretically use either DNS or DHCP.
DNS is working perfectly for me.
DHCP is also working great for IE, but not for current Firefox (1.5.0.7).
Wireshark suggests that it isn't even checking for this feature (it looks for WPAD via DNS & WINS broadcast, but no DHCP INFORM which is what IE uses)

Reproducible: Always

Steps to Reproduce:
1.Configure Network for DHCP auto-proxy detection
2.Configure Firefox to use Auto proxy detection
3.Launch Firefox

Actual Results:  
No access to Internet (if direct access is blocked)

Expected Results:  
Proxy access configured according to PAC file

DHCP is setting the 252 option to:
http://x.x.x.x:8080/wpad.dat

(x.x.x.x is the IP of the Proxy server, port 80 is used by the proxy service, hence using 8080)
Comment 1 Jo Hermans 2006-10-16 14:56:21 PDT
There is some code in attachment 121707 [details] [diff] [review] (see bug 28998), but it was never checked in.
Comment 2 Christian Schmidt 2008-02-06 13:58:52 PST
*** Bug 350759 has been marked as a duplicate of this bug. ***
Comment 3 Robert Strong [:rstrong] (use needinfo to contact me) 2008-07-08 15:20:55 PDT
*** Bug 440547 has been marked as a duplicate of this bug. ***
Comment 4 WADA 2008-07-09 06:08:16 PDT
Bug 444071 seems to be similar issue to this bug, and the bug opener of Bug 444071 says following in Bug 444071 Comment #8.
> using "Work offline", immediately followed by "Work online" indeed solves the problem!

To Fran Boon(bug opener): (same question as Bug 444071 Comment #6)
Can following be a workaround when the problem occurs?
  "Work offline", then return to "Work online" again.
Comment 5 benc 2008-07-09 19:34:04 PDT
Jo: As I recall, the WPAD implementation ignored DHCP.

Should we work on implementing that here? If so, lets make this NEW.

Then we need to find out if the DHCP implementation is OS-specific. If so, then we should make this a meta bug, and then create one bug per-OS implementation.

Fran: can you confirm the DHCP setting is changing (are you using ipconfig /all)?
Comment 6 Martin Čmelík 2008-07-30 02:20:10 PDT
Hi,

I have same problem. Can somebody repair it?
In our company is it problem and colleagues must manual setup web proxy server, but after that doesnt take in matter internal address exceptions...

Please look on it!
Thank you so much!
Comment 7 Jo Hermans 2008-07-30 02:41:11 PDT
(In reply to comment #6)
> I have same problem. Can somebody repair it?
> In our company is it problem and colleagues must manual setup web proxy server,
> but after that doesnt take in matter internal address exceptions...

The DHCP option will return the location of the PAC-file : your colleagues should use that same PAC file when configuring their proxy-server, in the field 'Automatic proxy configuration URL', *not* the ipaddress of the proxy-server in the manual configuration. The PAC-file also contains those internal address exceptions.

If the PAC-file can be stored at the URL <http://wpad.example.com/wpad.dat> (replacing example.com with the domain of your company), then you can also use the 'Auto-detect proxy settings' field, and it's even easier (it's also supported by Internet Explorer). The DHCP option is mainly used when the PAC-file can't be found at that particular URL, and the user needs some help in the automatic configuration. Unless the whole URL is configured manually ofcourse.

If you do not have a PAC-file at all, then you can't use the 'Automatic' or 'Auto-detect' settings at all, and neither can you use the DHCP option.
Comment 8 Martin Čmelík 2008-07-30 02:55:17 PDT
Thanks for answer!

I will try it, but it is not so much usable for all peoples... in every location they must change their proxy settings (yeah i know that exist proxy "changers"..)

Is really big problem to add this feature in Firefox?
Comment 9 Martin Čmelík 2008-07-30 02:56:51 PDT
btw: another problem is with Toolbars (icq, google, yahoo, so on...)

They dont accept configuration scripts or manual configuration...
Comment 10 Nick 2009-06-12 06:38:52 PDT
This is the same problem I have. I can successfully use WPAD and auto detect in IE using DHCP, but not in Firefox. Can this be looked at? Auto proxy should support both methods.
Comment 11 Chee Wen Chan 2010-08-08 19:18:33 PDT
Base on the advice from Jo Hermans comment in above, I have tried this and put in comments in Google Chrome bug's report as it is a similar problem. https://code.google.com/p/chromium/issues/detail?id=18575#c5
Comment 12 Kevin McCaleb 2011-01-06 07:34:29 PST
At my company we use a multi-site, hierarchical web proxy model primarily for two purposes; first, to route users to a geographically local proxy for performance and bandwidth usage considerations, and second to even the load across our internet-connected web proxy devices. To accomplish this we utilize location-aware load balancing to direct users to a local web server to retrieve a location-specific version of the WPAD configuration file. This is a fairly complex configuration to maintain across >10 widely dispersed locations, and is flawed since the load balancing solution is limited in its ability to determine user locations (it is fairly broad). The proxy devices service both end-user web access and application web access, as well as B2B socks-based traffic. Legacy configuration on application servers make it difficult to reconfigure these servers to segregate user and application traffic on the proxy devices. We would like to use DHCP to replace our DNS-based solution for locating the WPAD configuration file, as all user desktops are configured to use DHCP. DHCP scopes are easily mapped to specific geographic locations which would enable more granular routing and load balancing. Unfortunately we cannot move forward with this solution because of this bug (and the same bug in Chrome). We would greatly appreciate this bug being resolved in a not-too-distant release. Thank you.
Comment 13 Herbert Feutl 2011-07-01 00:21:55 PDT
after more than 4 years still no answer about future implementation!

would be nice to see the feature to get option 252 into firefox - DNS is sometimes tricky and not possible to server!
Comment 14 awroblew 2011-07-18 11:48:40 PDT
It is disappointing to see that there is no update on this issue! I am now force to block Firefox on all office PC (all 100+ of them) due to the fact that we are deploying proxy that is being deployed via DHCP. Sad so sad!
Comment 15 fyrch 2011-07-20 01:50:19 PDT
Same here. Have to block 150+ Firefox users because the DNS-way of delivering WPAD is not currently possible in my company and Firefox still can't get wpad via DHCP.
Comment 16 Jo Hermans 2011-07-20 09:14:07 PDT
Bumping up the status, which is not a promise that it would be fixed (I don't have anything to say over that). I noticed that Chrome has finally implemented support for this (Windows only !!!). The hard part is to support it on all platforms.
Comment 17 Stanislav GE 2012-02-15 08:21:05 PST
(In reply to fyrch from comment #15)
> Same here. Have to block 150+ Firefox users because the DNS-way of
> delivering WPAD is not currently possible in my company and Firefox still
> can't get wpad via DHCP.

The same for us. We can't use dns way because of company restriction.
Comment 18 nelsoncybernet 2012-02-16 06:44:34 PST
Still no progress on this issue ? Resolving this issue is crucial for corporate users.
Comment 19 costinel 2012-03-31 00:52:40 PDT
I'm too lazy to file a new bug and I just wanted to mention that after getting the PAC settings in network1, putting the computer in standby then waking it up in a PAC-free network2, firefox insists on using the other networks' proxy (which is unreachable, thus displaying the message that it cannot connect to proxy), even if I explicitly perform a dhcp release/renew. It only resumes working if I restart it.
firefox 12 beta, windows xp sp3
Comment 20 bibl2008 2012-04-24 14:03:32 PDT
firefox version 11 and 12.0 does not receive Proxy auto-config file by DHCP 252
Comment 21 Olo 2012-06-07 09:56:03 PDT
(In reply to bibl2008 from comment #20)
> firefox version 11 and 12.0 does not receive Proxy auto-config file by DHCP
> 252

What about version 13? Does anyone know if Mozilla is about to fix it?
Using proxy through auto-config file by DHCP is the only reasonable solution for companies using DirectAccess.
Comment 22 Malcolm McLean 2012-06-26 03:00:59 PDT
I'm using 14 beta and it still doesn't implement DHCP for WPAD.

This is a particular issue for us because our company is split between multiple geographical locations each with its own proxy server, but using a single DNS name for the internal domain. This makes using wpad.domain.com more difficult.

However, we already have the proxy info configured via DHCP for use by IE and Chrome.

If Firefox would support DHCP for proxy auto-detect, it would allow the browser to integrate into existing networks far easier and without having to manually configure each one to point to the .pac file.
Comment 23 Olo 2012-11-23 01:18:58 PST
Could anyone confirm version 17.0 (ESR) has fixed the lack of support for DHCP option 252?
Comment 24 Jo Hermans 2012-11-23 04:41:26 PST
No patch has been checked in (or even proposed), so how could it have been fixed ?
Comment 25 Daniel Veditz [:dveditz] 2013-01-30 14:44:14 PST
Equivalent Chromium bug (now fixed, on windows at least) is https://code.google.com/p/chromium/issues/detail?id=18575
Comment 26 nico.haller 2013-01-30 23:49:44 PST
(In reply to Daniel Veditz [:dveditz] from comment #25)
> Equivalent Chromium bug (now fixed, on windows at least) is
> https://code.google.com/p/chromium/issues/detail?id=18575

Seems like Firefox is the only important browser left that still won't support this feature. Is there a plan to finally assign this to someone?
This would be crucial to rollout Firefox in corporate networks!
Comment 27 Phoenix 2013-05-02 05:49:20 PDT
Any chances that this bug got some attention in near future?
Comment 28 Pavel Nedved 2013-05-02 16:35:16 PDT
The is a great increase in users demands for this feature inside vpn private networks. DNS Query for WPAD should not be the first inly thing to do for AutoDetect Proxy settings. Sometimes DNS Query for WPAD is not possible, because the pcs are not is a domain, or dns do not know the entry, or simply some routers does not relay the request

DHCP Comming first, before DNS, Firefox should check for option 252, in the dhcp settings, by requesting windows the DhcpRequestParams command. If windows has not requested the option252, a dhcpinform should be submitted to get the option. 

This is really important for trusted dhcp servers in private secured networks.

If of course firefox do not get the option 252 from windows, it should fallback to DNS WPAD METHOD.

But first we would like Firefox to implement correctly the DHCP WPAD METHOD

Thanks
Comment 29 nelsoncybernet 2013-07-03 18:35:48 PDT
I have to say 'bye-bye' to firefox. I switched the browser of over 300 PCs in my corporate environment to Google Chrome and very satisfied with the outcome. 
I'm tired of the undefined waiting for this bug to be settled.
Comment 30 nicolas 2013-07-04 04:54:16 PDT
When this 7 years old bug will be fixed ? I use DHCP WPAD in a school environment with more than 500 computers, I would be glad to have this feature working on Firefox...
Comment 31 ertymail 2013-09-05 08:19:58 PDT
we exploit a network of ~1000 computers, the most part from which has firefox. It's really painfull for me, as software administrator, to maintain dns-wpad.
Please, please, fix it BUG and add dhcp-wpad method!
Comment 32 zeolla 2014-01-09 06:44:38 PST
As another large corporation with tens thousands of computers, this is stopping us from implementing much more elegant and efficient solutions.  We are considering de-supporting firefox for our user base because of this...  PLEASE fix, or at least get some traction!  

Thanks.
Comment 33 Phoenix 2014-01-09 12:13:39 PST
Firefox is not usable in corporate environment, forget about it and use IE
Comment 34 philippe sampont 2014-01-10 13:26:17 PST
(In reply to comment #31 and #32)
There is 2 solutions to meet your request : Either you paid an expert to path Firefox or your change the organization of your corporate network. ;) If no company pays to change Firefox, then Firefox will not be able to use in business.
Comment 35 Josep Pujadas-Jubany 2014-08-16 13:28:51 PDT
Option 252 is for reserved private use:

http://www.iana.org/assignments/bootp-dhcp-parameters/bootp-dhcp-parameters.xhtml

It's Microsoft choice, http://superuser.com/questions/382964/dhcp-option-252-what-is-it

Unfortunatelly, DHCP hasn't an standard option for indicating de proxy.

DNS discovery must be used if you want to find the proxy:

http://findproxyforurl.com/wpad-introduction/
Comment 36 polly.shaw 2016-11-28 23:16:17 PST
I am thinking of working on this as it would help me out a lot. The link at the bottom of Josep's post now mentions DHCP.

Note You need to log in before you can comment on or make changes to this bug.